/*  smpfact.cpp  by K.Tsuru  */
//
// SLong sample program
// It has been rewritten using "ostream" since version 2.21.
//
/* 64 bit version
Input N(when N<=0 quit) = ? 10 0000 0000
N is too large.Input N(when N<=0 quit) = ? 100000000
****** Calculating 100000000! ******
 100000000! CPU time : 612.813(sec) figures = 756570144 (by Stirling formula = 756570557)
FFTUsedTimes() = 717431(times)
Do you want to output result ? It maybe need much time on DOS.Yes(1)/No(0)=?
*/

const char* title = "<<<<<< Factrial N! calculation >>>>>>";

#include "sn.h"
SLong FactSpeed(uint n)
{
	SLong f;
	Timer timer;
	double t;

	cout << "****** Calculating " << n << "! ******" << endl;
	timer.Start();
	f = Fact(n);
	t = timer.Stop();

	long fig = f.DFigures();
	cout << " " << n << "! CPU time : " << t <<"(sec) ";
	cout <<  "figures = " << fig << " (by Stirling formula = " << Stirling(n) << ")"<< endl;
	cout << "FFTUsedTimes() = " << f.FFTUsedTimes() << "(times)" << endl;
	cerr << "Do you want to output result ?";
	if (fig > 100000) cerr << " It maybe need much time on DOS.";
	cerr << "Yes(1)/No(0)=? ";
	if(GetInt()){
		cout << n << "!= "<< f << endl;
    }
	cout << " " << n << "! CPU time : " << t <<"(sec) ";
	cout << "figures = " << f.DFigures() << "(by Stirling formula = " << Stirling(n) << ")" << endl;
	cout << "FFTUsedTimes() = " <<  f.FFTUsedTimes() << endl;
	Wait();
	return f;
}
int main()
{
	SLong f;
	int k;
	ulong n = 0, max_fig = (ulong)f.MaxSize()*(ulong)DFIGURES;	// ver. 2.17.1

	cerr << title << endl;
	cerr << "Maxmum figures in a decimal system = " << max_fig << "." << endl;
	while(1){
		while(1){
			cerr << "Input N(when N<=0 quit) = ? ";
			if((k = GetInt())<=0 ) break;
			n = (ulong)k;
			if(Stirling(n) > max_fig) cerr << "N is too large.";	// ver. 2.17.1
			else break;
		}
		if(k<=0) break;
		FactSpeed(n);
	}

	Ending();
}
