/*  smphypb.cpp  by K.Tsuru  */ 
static const char* title = "<<<<< A sample program for hyperboric functions >>>>>";

#include "sn.h"

void ShowCalcInfo(const SDouble& c, double cpu_time){
	cout << "Up to " << c.UpToTerm() << "th terms, cpu time = " << cpu_time << endl;
}
void FuncXTest(SDouble (*pfunc)(const SDouble&),
    const char* fname, const char* range)
{
	Timer timer;
	double cpu_time;
	SDouble x, r;

	while(1){
		cerr << "To calculate " << fname;
		if(range == NULL){
			cerr << " input x = (Abort when x = 0)? ";
			cin >> x;
		} else {
			while(1){
				cerr <<  " input x(" << range << ") (Abort when x = 0)? ";
				cin  >> x;
				if( x == 0.0 ) break; // Use "0.0". "0" yields an error.
				if( (pfunc == Acosh) && (Dabs(x) < 1.0) ) continue;
				else if( (pfunc == Atanh) && (Dabs(x) >= 1.0) ) continue;
				break;
			}
		}
		if(x == 0.0) break;
		cout << "Your x = " << x << endl;
		cerr << "Calculating " << fname << endl;
		timer.Start();
		r = (*pfunc)(x);
		cpu_time = timer.Stop();
		cout << r << endl;
		ShowCalcInfo(r, cpu_time);
		Wait();
	}
}
int main()
{
	cerr << title << endl;
	RealSize C;

	int fig = -1;
	cerr << "Input your effective figures / " << DFIGURES << "= ? ";
	while(fig < 10) fig = GetInt();

	C.SetEffFig(fig);

	FuncXTest(Sinh, "Sinh(x)", NULL);
	FuncXTest(Cosh, "Cosh(x)", NULL);
	FuncXTest(Tanh, "Tanh(x)", NULL);
	FuncXTest(Asinh, "Asinh(x)",NULL);
	FuncXTest(Acosh, "Acosh(x)", "x >= 1.0");
	FuncXTest(Atanh, "Atanh(x)", "|x| < 1.0");

	C.SetEffFig(0);
	Ending();
}
